variables:
  # disable the Gradle daemon for Continuous Integration servers
  GRADLE_OPTS: "-Dorg.gradle.daemon=false"

stages:
  - build
  - test
  - publish

build:linux:jdk11:
  image: amazoncorretto:11 
  stage: build
  script:
    # create the library packages for distribution
    - ./gradlew --build-cache assemble --info
    - mkdir libs
    - cp build/libs/*.jar libs/
    # create checksum file to make sure we're distributing the right thing
    - cd libs
    - md5sum *.jar > checksums.txt
  artifacts:
    name: "$CI_COMMIT_REF_NAME-snapshot"
    paths:
      - libs
    expire_in: 1 week
  cache:
    key: "$CI_COMMIT_REF_NAME"
    policy: push
    paths:
      - build
      - .gradle

test:linux:jdk11:
  image: amazoncorretto:11
  stage: test
  script:
    - ./gradlew test
  cache:
    key: "$CI_COMMIT_REF_NAME"
    policy: pull
    paths:
      - build
      - .gradle

test:dependencyupdates:
  image: amazoncorretto:11
  stage: test
  script:
    - ./gradlew dependencyUpdates

publish:gitlab-snapshot:
  image: amazoncorretto:11
  stage: publish
  script:
    - ./gradlew publish -PjobToken=$CI_JOB_TOKEN
  cache:
    key: "$CI_COMMIT_REF_NAME"
    policy: push
    paths:
      - build
      - .gradle
  rules:
    - if: '$CI_COMMIT_REF_NAME == "master"'
      when: always
    - when: never

publish:gitlab:
  image: amazoncorretto:11
  stage: publish
  script:
    - ./gradlew publish -Prelease=true -PjobToken=$CI_JOB_TOKEN
  cache:
    key: "$CI_COMMIT_REF_NAME"
    policy: push
    paths:
      - build
      - .gradle
  rules:
    - if: '$CI_COMMIT_TAG != null'
      when: always
    - when: never
